import { DOMAttributes, EventHandler, SyntheticEvent, MutableRefObject } from 'react';
declare type HTMLElRef = MutableRefObject<HTMLElement>;
declare type CustomEvent = {
    event?: SyntheticEvent<any, Event>;
    portal: HTMLElRef;
    targetEl: HTMLElement;
};
declare type CustomEventHandler = (customEvent: CustomEvent) => void | HTMLElRef;
declare type EventHandlers = {
    [K in keyof DOMAttributes<K>]?: EventHandler<SyntheticEvent<any, Event>>;
};
declare type UsePortalOptions = {
    closeOnOutsideClick?: boolean;
    closeOnEsc?: boolean;
    renderOnClickedElement?: boolean;
    renderBelowClickedElement?: boolean;
    bindTo?: HTMLElement;
    isOpen?: boolean;
    stateful?: boolean;
    onOpen?: CustomEventHandler;
    onClose?: CustomEventHandler;
} & EventHandlers;
export default function usePortal({ closeOnOutsideClick, closeOnEsc, renderOnClickedElement, renderBelowClickedElement, bindTo, // attach the portal to this node in the DOM
isOpen: defaultIsOpen, onOpen, onClose, ...eventHandlers }?: UsePortalOptions): any;
export {};
